
function E = EkvivKo(M, tulostus);
%ekvivalenssitesti:	function E = EkvivKo(M, tulostus);
%	miss
%	M = relaation nelimuotoinen 0-1-matriisi
%	tulostus = optionaalinen, mik tahansa, esim. ' ',
%		aiheuttaa tulostuksen tekstin
%	Tarkastaa, onko relaatio ekvivalenssi,
%	siis refleksiivinen, symmetrinen ja transitiivinen.
%	KYTT: ReflKo, SymmKo, TransKo

%	Martti E. Pesonen 25.9.2000 ja 26.10.2004

M = logical(M);
R = ReflKo(M);
S = SymmKo(M);
T = TransKo(M);
E = R & S & T;
if (nargin > 1)
   if R, disp('refleksiivinen'); end;
	if S, disp('symmetrinen'); end;
	if T, disp('transitiivinen'); end;
   if E, disp('EKVIVALENSSI'); end;
end;




