
function PiirNuo1(M, alkiopari, vari);
%piirtofunktioita 1:	function PiirNuo1(M, alkiopari, vari);
%	miss
%	M		= relaation nelimuotoinen 0-1-matriisi
%	alkiopari	= alkiopari muodossa [i j]
%	vari		= optionaalinen, piirtovri, 
%				oletusarvo '-r' = punainen nuoli
%	Piirt nuolen suunnatuksi janaksi  i -> j.
%	Relaation tulee olla mritelty jossakin joukossa  X x X. 
%	Jos relaatio on mritelty joukossa X x Y, 
%		piirr funktiolla 'PiirNuo2'.

%	Martti E. Pesonen 25.5.1991  17.9.2000 ja 26.10.2004

M = logical(M);
oletusvari = '-r'; ympsade = 1;
nkanta = 0.03*ympsade; npit = 0.1*ympsade;
if (nargin < 3)  vari = oletusvari;  end	% oletusvri punainen
n  = max(size(M));
kulmat= (alkiopari - 1)*(2*pi)/n + pi/2;% alkioparin kulmat
xt = ympsade*cos(kulmat);			% x-koordinaatit
yt = ympsade*sin(kulmat);			% y-koordinaatit
z1 = [xt(1) yt(1)];			% tason
z2 = [xt(2) yt(2)];			%  pisteet
d  = norm(z2 - z1);			% niiden etisyys
a = (z2 - z1)/d;			% yksikkvektori z1 -> z2
b = [a(2) -a(1)];			% kohtisuora yksikkvektori
z = z1 + (3/4)*(z2 - z1);		% nuolikolmio 3/4 phn z1:st
npit2 = min( npit, d/4);
nuoli = [z+nkanta*b; z-nkanta*b; z+npit2*a; z+nkanta*b];  % kolmion krjet
plot( xt, yt,vari)				% janan z1 -> z2 piirto
plot( nuoli(:,1), nuoli(:,2), vari)		% nuolen krki (kolmio)
