

function PiirRel1( M, vari);
%piirtofunktioita 1:	function PiirRel1( M, vari);
%	miss
%	M	= relaation nelimuotoinen 0-1-matriisi
%	vari	= optionaalinen, piirtovri, vain entiseen kuvaan piirrossa
%			jos esiintyy, piirretn kaaret vrill 'vari'
%	Piirt 
%	  alkiot 1-steiselle ympyrn kehlle,
%	  silmukat alkiota sivuaviksi ympyriksi,
%	  nuolet suunnatuiksi janoiksi.
%	Relaation tulee olla mritelty jossakin joukossa  X x X. 
%	Jos relaatio on mritelty joukossa X x Y, 
%		piirr funktiolla 'PiirRel2'.

%	Martti E. Pesonen 25.5.1991 11.9.2000 ja 26.10.2004

M = logical(M);
xminmax = [-1.5 1.9]; yminmax = [-1.3 1.3]; oletusvari = '-r';
ympsade = 1; smaxsade = 0.1*ympsade; numetkerr = (ympsade + 0.2)/ympsade;
jako = 10; nkanta = 0.03*ympsade; npit = 0.1*ympsade;
[n, m]  = size(M);
if (n == m)
  if (nargin == 1)
    clf, hold off; axis([xminmax yminmax]); axis('off');
    hold on; vari = oletusvari;
  end
  kulmat = ((1:n) - 1) * (2*pi)/n + pi/2;	% kaikkien n solmun kulmat
  xt = ympsade*cos(kulmat);			% x-koordinaatit
  yt = ympsade*sin(kulmat);			% y-koordinaatit
  plot( xt, yt, 'ow')
  for i = 1:n  text( numetkerr*xt(i), numetkerr*yt(i), int2str(i)); end
  solmut = find(diag(M))';			% solmut, joissa silmukoita
  for i = solmut
    kp		= [xt(i); yt(i)] * (1 + smaxsade/ympsade);
    kkulmat	= (0:jako)'*(2*pi/jako);
    plot( cos(kkulmat)*smaxsade + ones(size(kkulmat))*kp(1,:),...
          sin(kkulmat)*smaxsade + ones(size(kkulmat))*kp(2,:), vari)
  end
  M		= M - diag(diag(M));
  lahtosolmut	= find(any(M'));
  for i = lahtosolmut 
    J	= find(M(i,:));  		  m  = max(size(J));
    X1	= xt(i) * ones(1,m); X2 = xt(J);  Y1 = yt(i) * ones(1,m); Y2 = yt(J);
    plot( [X1; X2], [Y1; Y2], vari)
    etaisyydet = sqrt((X2 - X1).^2 + (Y2 - Y1).^2);
    Z1 	= [X1; Y1]; 			  Z2 = [X2; Y2];
    A	= (Z2 - Z1)./([1;1]*etaisyydet);  B  = [A(2,:); -A(1,:)];
    Z	= Z1 + (3/4)*(Z2 - Z1);
    npit2 = [1;1]*min( ones(1,m)*npit, etaisyydet/4);
    nuoli = [Z+nkanta*B;  Z-nkanta*B;  Z+npit2.*A;  Z+nkanta*B];  
    plot( nuoli([1 3 5 7],:), nuoli([2 4 6 8],:), vari)
  end
else
  disp('Kyt piirtoon funktiota "piirRel2".')
end